/*
 * \brief  CPU state
 * \author Christian Prochaska
 * \author Stefan Kalkowski
 * \date   2011-04-15
 *
 * This file contains the x86_64-specific part of the CPU state.
 */

/*
 * Copyright (C) 2011-2013 Genode Labs GmbH
 *
 * This file is part of the Genode OS framework, which is distributed
 * under the terms of the GNU General Public License version 2.
 */

#ifndef _INCLUDE__X86_64__CPU__CPU_STATE_H_
#define _INCLUDE__X86_64__CPU__CPU_STATE_H_

#include <base/stdint.h>

namespace Genode { struct Cpu_state; }

struct Genode::Cpu_state
{
	addr_t ip     = 0;
	addr_t sp     = 0;
	addr_t r8     = 0;
	addr_t r9     = 0;
	addr_t r10    = 0;
	addr_t r11    = 0;
	addr_t r12    = 0;
	addr_t r13    = 0;
	addr_t r14    = 0;
	addr_t r15    = 0;
	addr_t rax    = 0;
	addr_t rbx    = 0;
	addr_t rcx    = 0;
	addr_t rdx    = 0;
	addr_t rdi    = 0;
	addr_t rsi    = 0;
	addr_t rbp    = 0;
	addr_t ss     = 0;
	addr_t eflags = 0;
	addr_t trapno = 0;
};

#endif /* _INCLUDE__X86_64__CPU__CPU_STATE_H_ */
